from time import sleep
from motesim import Simulator, Mote
from random import random,randint

###################################################
def script():
    x=[]
    while True :
        sleep(20)
        y = randint(1,23)
        if y not in x :
            sim.nodes[y].shutdown()
            x.append(y)

###################################################
class DebugMote(Mote):
    def debug(self, msg):
       # delete old link, if exists
        if hasattr(self,'parent') and self.parent != 0xFFFF:
            sim.scene.dellink(self.id,self.parent,'parentlink')

        # draw new link and record it for later deletion
        self.parent = int(msg.replace('parent = ',''))
        if self.parent != 0xFFFF:
            sim.scene.addlink(self.id,self.parent,'parentlink')

###################################################
APP = 'build/sim/Chamelon.elf',
sim = Simulator()
"""
sim.scene.linestyle('parentlink',  # create a link style named 'parentlink'
    color=(0,.8,0), 
    width=2, 
    dash=(3,3), 
    arrow='head',
)
"""

for x in range(5):
    for y in range(5):
        mote = DebugMote(APP,txRange=150)
        pos = (x*100+100+random()*30, y*100+100+random()*20)
        sim.addNode(mote, pos)

(addr,port) = sim.nodes[0].uart.activateSocket(port=randint(50000,60000))
(addr2,port2) = sim.nodes[24].uart.activateSocket(port=randint(50000,60000))
print "*** Activate UART on TCP port %d" % port
print "*** Activate UART on TCP port %d" % port2
#sim.run()
sim.run()
